Index: main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_webservices.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_webservices.py	(revision 10501)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_webservices.py	(revision 10502)
@@ -4,13 +4,11 @@
 from cStringIO import StringIO
 from zope.app.testing.xmlrpc import ServerProxy
-from zope.component import createObject, getUtility
-from zope.component.hooks import setSite
-from zope.testbrowser.testing import Browser
-from waeup.kofa.app import University
+from zope.component import getUtility
 from waeup.kofa.interfaces import IExtFileStore, IFileStoreNameChooser
-from waeup.kofa.testing import FunctionalLayer, FunctionalTestCase
+from waeup.kofa.testing import FunctionalLayer
 from waeup.kofa.students.payments import StudentOnlinePayment
 from waeup.kofa.students.tests.test_browser import StudentsFullSetup
 from waeup.kofa.students.studylevel import StudentStudyLevel, CourseTicket
+
 
 class XMLRPCTests(StudentsFullSetup):
@@ -69,5 +67,5 @@
         self.assertEqual(result, 'K1000000')
         self.assertEqual(self.student_id, result)
-        REQUEST_XML="""\
+        REQUEST_XML = """\
 <?xml version="1.0"?>
 <methodCall>
@@ -79,5 +77,5 @@
 </params>
 </methodCall>"""
-        RESPONSE_XML="""\
+        RESPONSE_XML = """\
 <?xml version='1.0'?>
 <methodResponse>
@@ -132,5 +130,5 @@
         result = server.get_courses_by_session('Nonsense')
         self.assertEqual(result, None)
-        REQUEST_XML="""\
+        REQUEST_XML = """\
 <?xml version="1.0"?>
 <methodCall>
@@ -142,5 +140,5 @@
 </params>
 </methodCall>"""
-        RESPONSE_XML="""\
+        RESPONSE_XML = """\
 <?xml version='1.0'?>
 <methodResponse>
@@ -171,7 +169,7 @@
         self.assertEqual(result, None)
         result = server.get_students_by_course('CRS1', '2012')
-        self.assertEqual(result, [['K1000000', '234', 'my adviser', 0],])
+        self.assertEqual(result, [['K1000000', '234', 'my adviser', 0], ])
         result = server.get_students_by_course('CRS1')
-        self.assertEqual(result, [['K1000000', '234', 'my adviser', 0],])
+        self.assertEqual(result, [['K1000000', '234', 'my adviser', 0], ])
         payment = StudentOnlinePayment()
         payment.p_id = 'my-id'
@@ -181,6 +179,6 @@
         self.student['payments']['my-payment'] = payment
         result = server.get_students_by_course('CRS1')
-        self.assertEqual(result, [['K1000000', '234', 'my adviser', 12.12],])
-        REQUEST_XML="""\
+        self.assertEqual(result, [['K1000000', '234', 'my adviser', 12.12], ])
+        REQUEST_XML = """\
 <?xml version="1.0"?>
 <methodCall>
@@ -193,5 +191,5 @@
 </params>
 </methodCall>"""
-        RESPONSE_XML="""\
+        RESPONSE_XML = """\
 <?xml version='1.0'?>
 <methodResponse>
@@ -220,5 +218,5 @@
         self.assertEqual(result,
             ['Anna Tester', 'CERT1', '1234', 'aa@aa.ng'])
-        REQUEST_XML="""\
+        REQUEST_XML = """\
 <?xml version="1.0"?>
 <methodCall>
@@ -230,5 +228,5 @@
 </params>
 </methodCall>"""
-        RESPONSE_XML="""\
+        RESPONSE_XML = """\
 <?xml version='1.0'?>
 <methodResponse>
@@ -258,5 +256,5 @@
         binary = img.read()
         self.assertEqual(binary, result)
-        REQUEST_XML="""\
+        REQUEST_XML = """\
 <?xml version="1.0"?>
 <methodCall>
@@ -268,5 +266,5 @@
 </params>
 </methodCall>"""
-        RESPONSE_XML="""\
+        RESPONSE_XML = """\
 <?xml version='1.0'?>
 <methodResponse>
@@ -290,5 +288,5 @@
         result = server.get_paid_sessions('123')
         self.assertEqual(result, {'2009': 12.12})
-        REQUEST_XML="""\
+        REQUEST_XML = """\
 <?xml version="1.0"?>
 <methodCall>
@@ -300,5 +298,5 @@
 </params>
 </methodCall>"""
-        RESPONSE_XML="""\
+        RESPONSE_XML = """\
 <?xml version='1.0'?>
 <methodResponse>
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/webservices.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/webservices.py	(revision 10501)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/webservices.py	(revision 10502)
@@ -16,5 +16,4 @@
 ## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ##
-
 import grok
 import xmlrpclib
@@ -22,5 +21,5 @@
 from zope.catalog.interfaces import ICatalog
 from waeup.kofa.interfaces import IUniversity, IExtFileStore
-    
+
 
 def get_student(students, identifier):
@@ -53,4 +52,5 @@
 #    grok.permissions('waeup.xmlrpc',)
 
+
 class StudentsXMLRPC(grok.XMLRPC):
     """Student related XMLRPC webservices.