Index: in/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studentsreportgeneratorpage.pt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studentsreportgeneratorpage.pt	(revision 10548)
+++ 	(revision )
@@ -1,49 +1,0 @@
-<form  i18n:domain="waeup.kofa"  method="POST">
-  <p i18n:translate="">
-    Please pick the session and study modes group
-    for which the report should be generated.
-    The report data will be calculated and then made available for you
-    to view/download.
-  </p>
-  <br />
-  <div class="clearfix">
-    <label for="session" i18n:translate="">Study Modes Group:</label>
-    <div class="input">
-      <select name="mode">
-        <span tal:repeat="items view/modes" tal:omit-tag="">
-          <option
-              tal:define="name python: items[1]; title python: items[0]"
-              tal:attributes="value name">
-            <span tal:replace="title">TITLE</span>
-          </option>
-        </span>
-      </select>
-      <div class="help-inline" i18n:translate="">
-        Set study modes filter.
-      </div>
-    </div>
-    <br />
-    <label for="session">Academic Session:</label>
-    <div class="input">
-      <select name="session" i18n:translate="">
-        <span tal:repeat="items view/sessions" tal:omit-tag="">
-          <option
-              tal:define="name python: items[1]; title python: items[0]"
-              tal:attributes="value name">
-            <span tal:replace="title">TITLE</span>
-          </option>
-        </span>
-      </select>
-      <div class="help-inline" i18n:translate="">
-        Select academic session to report.
-      </div>
-    </div>
-
-  </div>
-  <div class="input">
-    <input i18n:translate="" type="submit" class="btn primary"
-           name="CREATE" value="Create" />
-    <a class="btn secondary" href=""
-       tal:attributes="href view/parent_url">Cancel</a>
-  </div>
-</form>
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/browser_templates/studentsreportgeneratorpage.pt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/browser_templates/studentsreportgeneratorpage.pt	(revision 10549)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/browser_templates/studentsreportgeneratorpage.pt	(revision 10549)
@@ -0,0 +1,49 @@
+<form  i18n:domain="waeup.kofa"  method="POST">
+  <p i18n:translate="">
+    Please pick the session and study modes group
+    for which the report should be generated.
+    The report data will be calculated and then made available for you
+    to view/download.
+  </p>
+  <br />
+  <div class="clearfix">
+    <label for="session" i18n:translate="">Study Modes Group:</label>
+    <div class="input">
+      <select name="mode">
+        <span tal:repeat="items view/modes" tal:omit-tag="">
+          <option
+              tal:define="name python: items[1]; title python: items[0]"
+              tal:attributes="value name">
+            <span tal:replace="title">TITLE</span>
+          </option>
+        </span>
+      </select>
+      <div class="help-inline" i18n:translate="">
+        Set study modes filter.
+      </div>
+    </div>
+    <br />
+    <label for="session">Academic Session:</label>
+    <div class="input">
+      <select name="session" i18n:translate="">
+        <span tal:repeat="items view/sessions" tal:omit-tag="">
+          <option
+              tal:define="name python: items[1]; title python: items[0]"
+              tal:attributes="value name">
+            <span tal:replace="title">TITLE</span>
+          </option>
+        </span>
+      </select>
+      <div class="help-inline" i18n:translate="">
+        Select academic session to report.
+      </div>
+    </div>
+
+  </div>
+  <div class="input">
+    <input i18n:translate="" type="submit" class="btn primary"
+           name="CREATE" value="Create" />
+    <a class="btn secondary" href=""
+       tal:attributes="href view/parent_url">Cancel</a>
+  </div>
+</form>