Index: in/waeup.kofa/trunk/src/waeup/kofa/students/reports/browser_templates/studentsreportgeneratorpage.pt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/browser_templates/studentsreportgeneratorpage.pt	(revision 10549)
+++ 	(revision )
@@ -1,49 +1,0 @@
-<form  i18n:domain="waeup.kofa"  method="POST">
-  <p i18n:translate="">
-    Please pick the session and study modes group
-    for which the report should be generated.
-    The report data will be calculated and then made available for you
-    to view/download.
-  </p>
-  <br />
-  <div class="clearfix">
-    <label for="session" i18n:translate="">Study Modes Group:</label>
-    <div class="input">
-      <select name="mode">
-        <span tal:repeat="items view/modes" tal:omit-tag="">
-          <option
-              tal:define="name python: items[1]; title python: items[0]"
-              tal:attributes="value name">
-            <span tal:replace="title">TITLE</span>
-          </option>
-        </span>
-      </select>
-      <div class="help-inline" i18n:translate="">
-        Set study modes filter.
-      </div>
-    </div>
-    <br />
-    <label for="session">Academic Session:</label>
-    <div class="input">
-      <select name="session" i18n:translate="">
-        <span tal:repeat="items view/sessions" tal:omit-tag="">
-          <option
-              tal:define="name python: items[1]; title python: items[0]"
-              tal:attributes="value name">
-            <span tal:replace="title">TITLE</span>
-          </option>
-        </span>
-      </select>
-      <div class="help-inline" i18n:translate="">
-        Select academic session to report.
-      </div>
-    </div>
-
-  </div>
-  <div class="input">
-    <input i18n:translate="" type="submit" class="btn primary"
-           name="CREATE" value="Create" />
-    <a class="btn secondary" href=""
-       tal:attributes="href view/parent_url">Cancel</a>
-  </div>
-</form>
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/browser_templates/studentstatisticsreportgeneratorpage.pt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/browser_templates/studentstatisticsreportgeneratorpage.pt	(revision 10550)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/browser_templates/studentstatisticsreportgeneratorpage.pt	(revision 10550)
@@ -0,0 +1,49 @@
+<form  i18n:domain="waeup.kofa"  method="POST">
+  <p i18n:translate="">
+    Please pick the session and study modes group
+    for which the report should be generated.
+    The report data will be calculated and then made available for you
+    to view/download.
+  </p>
+  <br />
+  <div class="clearfix">
+    <label for="session" i18n:translate="">Study Modes Group:</label>
+    <div class="input">
+      <select name="mode">
+        <span tal:repeat="items view/modes" tal:omit-tag="">
+          <option
+              tal:define="name python: items[1]; title python: items[0]"
+              tal:attributes="value name">
+            <span tal:replace="title">TITLE</span>
+          </option>
+        </span>
+      </select>
+      <div class="help-inline" i18n:translate="">
+        Set study modes filter.
+      </div>
+    </div>
+    <br />
+    <label for="session">Academic Session:</label>
+    <div class="input">
+      <select name="session" i18n:translate="">
+        <span tal:repeat="items view/sessions" tal:omit-tag="">
+          <option
+              tal:define="name python: items[1]; title python: items[0]"
+              tal:attributes="value name">
+            <span tal:replace="title">TITLE</span>
+          </option>
+        </span>
+      </select>
+      <div class="help-inline" i18n:translate="">
+        Select academic session to report.
+      </div>
+    </div>
+
+  </div>
+  <div class="input">
+    <input i18n:translate="" type="submit" class="btn primary"
+           name="CREATE" value="Create" />
+    <a class="btn secondary" href=""
+       tal:attributes="href view/parent_url">Cancel</a>
+  </div>
+</form>
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/student_reports.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/student_reports.py	(revision 10549)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/student_reports.py	(revision 10550)
@@ -26,5 +26,5 @@
 from waeup.kofa.reports import IReport
 
-class IStudentsReport(IReport):
+class IStudentStatisticsReport(IReport):
 
     session = Attribute('Session to report')
@@ -118,6 +118,6 @@
     ]
 
-@implementer(IStudentsReport)
-class StudentsReport(Report):
+@implementer(IStudentStatisticsReport)
+class StudentStatisticsReport(Report):
     data = None
     session = None
@@ -125,5 +125,5 @@
 
     def __init__(self, session, mode, author='System'):
-        super(StudentsReport, self).__init__(
+        super(StudentStatisticsReport, self).__init__(
             args=[session, mode], kwargs={'author':author})
         self.session = academic_sessions_vocab.getTerm(session).title
@@ -150,5 +150,5 @@
 
 @implementer(IReportGenerator)
-class StudentsReportGenerator(grok.GlobalUtility):
+class StudentStatisticsReportGenerator(grok.GlobalUtility):
 
     title = _('Students')
@@ -156,5 +156,5 @@
 
     def generate(self, site, session=None, mode=None, author=None):
-        result = StudentsReport(session=session, mode=mode, author=author)
+        result = StudentStatisticsReport(session=session, mode=mode, author=author)
         return result
 
@@ -168,7 +168,7 @@
 from waeup.kofa.reports import get_generators
 grok.templatedir('browser_templates')
-class StudentsReportGeneratorPage(KofaPage):
-
-    grok.context(StudentsReportGenerator)
+class StudentStatisticsReportGeneratorPage(KofaPage):
+
+    grok.context(StudentStatisticsReportGenerator)
     grok.name('index.html')
     grok.require('waeup.manageReports')
@@ -215,12 +215,12 @@
         return
 
-class StudentsReportPDFView(grok.View):
-
-    grok.context(IStudentsReport)
+class StudentStatisticsReportPDFView(grok.View):
+
+    grok.context(IStudentStatisticsReport)
     grok.name('pdf')
     grok.require('waeup.Public')
 
     def render(self):
-        filename = 'StudentsReport_%s_%s_%s.pdf' % (
+        filename = 'StudentStatisticsReport_%s_%s_%s.pdf' % (
             self.context.session, self.context.mode,
             self.context.creation_dt_string)
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_student_reports.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_student_reports.py	(revision 10549)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_student_reports.py	(revision 10550)
@@ -5,6 +5,6 @@
 from zope.component import getUtility
 from waeup.kofa.interfaces import IJobManager
-from waeup.kofa.students.reports import (
-    get_students_by, StudentsReport, IStudentsReport)
+from waeup.kofa.students.reports.student_reports import (
+    get_students_by, StudentStatisticsReport, IStudentStatisticsReport)
 from waeup.kofa.students.tests.test_catalog import CatalogTestSetup
 from waeup.kofa.students.tests.test_browser import StudentsFullSetup
@@ -12,5 +12,5 @@
 from waeup.kofa.tests.test_async import FunctionalAsyncTestCase
 
-class StudentsReportTests(CatalogTestSetup):
+class StudentStatisticsReportTests(CatalogTestSetup):
 
     layer = FunctionalLayer
@@ -23,7 +23,7 @@
     def test_iface(self):
         # ensure we fullfill interface contracts
-        obj = StudentsReport(2010, 'Undergraduate Full-Time')
-        verifyClass(IStudentsReport, StudentsReport)
-        verifyObject(IStudentsReport, obj)
+        obj = StudentStatisticsReport(2010, 'Undergraduate Full-Time')
+        verifyClass(IStudentStatisticsReport, StudentStatisticsReport)
+        verifyObject(IStudentStatisticsReport, obj)
         return
 
@@ -69,10 +69,10 @@
     def test_create_pdf(self):
         self.create_cert('FAC2', 'dept2', 'CERT2')
-        report = StudentsReport(2010, 'Undergraduate Full-Time')
+        report = StudentStatisticsReport(2010, 'Undergraduate Full-Time')
         result = report.create_pdf()
         self.assertTrue(result.startswith('%PDF-'))
         return
 
-class StudentsReportUITests(StudentsFullSetup, FunctionalAsyncTestCase):
+class StudentStatisticsReportUITests(StudentsFullSetup, FunctionalAsyncTestCase):
 
     layer = FunctionalLayer
@@ -116,5 +116,5 @@
                          'application/pdf')
         self.assertTrue(
-            'filename="StudentsReport_2004_2005_All_' in
+            'filename="StudentStatisticsReport_2004_2005_All_' in
             self.browser.headers['content-disposition'])
         self.assertEqual(len(self.app['reports'].running_report_jobs), 1)
@@ -129,11 +129,11 @@
         logcontent = open(logfile).read()
         self.assertTrue(
-            'INFO - zope.mgr - students.reports.StudentsReportGeneratorPage - '
+            'INFO - zope.mgr - students.reports.student_reports.StudentStatisticsReportGeneratorPage - '
             'report %s created: Students (session=2004, mode=All)'
             % job_id in logcontent
             )
         self.assertTrue(
-            'INFO - zope.mgr - students.reports.StudentsReportPDFView - '
-            'report %s downloaded: StudentsReport_2004_2005_All_'
+            'INFO - zope.mgr - students.reports.student_reports.StudentStatisticsReportPDFView - '
+            'report %s downloaded: StudentStatisticsReport_2004_2005_All_'
             % job_id in logcontent
             )