Index: main/waeup.fceokene/trunk/src/waeup/fceokene/applicants/browser.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/applicants/browser.py	(revision 10569)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/applicants/browser.py	(revision 10570)
@@ -26,8 +26,12 @@
     PaymentReceiptActionButton, PDFActionButton)
 from waeup.kofa.applicants.pdf import PDFApplicationSlip
+from waeup.kofa.interfaces import IKofaUtils
+from waeup.kofa.browser.interfaces import IPDFCreator
 
 from kofacustom.nigeria.applicants.browser import (
     NigeriaExportPDFPaymentSlipPage, NigeriaApplicantManageFormPage,
     NigeriaApplicantDisplayFormPage, NigeriaApplicantEditFormPage)
+
+from waeup.fceokene.interfaces import MessageFactory as _
 
 from kofacustom.nigeria.applicants.interfaces import (
@@ -80,4 +84,23 @@
     def _reduced_slip(self):
         return getattr(self.context, 'result_uploaded', False)
+
+    def _getPDFCreator(self):
+        if 'putme' in self.target or 'pude' in self.target:
+            return getUtility(IPDFCreator, name='ibadan_pdfcreator')
+        return getUtility(IPDFCreator)
+
+    @property
+    def title(self):
+        container_title = self.context.__parent__.title
+        portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
+        ar_translation = translate(_('Application Record'),
+            'waeup.kofa', target_language=portal_language)
+        if 'putme' in self.target or 'pude' in self.target:
+            return 'IN AFFILIATION WITH UNIVERSITY OF IBADAN - %s %s %s' % (
+                container_title, ar_translation,
+                self.context.application_number)
+        return '%s - %s %s' % (container_title,
+            ar_translation, self.context.application_number)
+
 
     @property
Index: main/waeup.fceokene/trunk/src/waeup/fceokene/applicants/tests/test_browser.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/applicants/tests/test_browser.py	(revision 10569)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/applicants/tests/test_browser.py	(revision 10570)
@@ -63,8 +63,21 @@
         self.beccontainer.title = u'This is the bec2011 container'
         self.app['applicants']['bec2011'] = self.beccontainer
-
         delta = datetime.timedelta(days=10)
         self.beccontainer.startdate = datetime.datetime.now(pytz.utc) - delta
         self.beccontainer.enddate = datetime.datetime.now(pytz.utc) + delta
+
+        # Add ug applicants container
+        self.putmecontainer = ApplicantsContainer()
+        self.putmecontainer.mode = 'create'
+        self.putmecontainer.code = u'putme2011'
+        self.putmecontainer.prefix = u'putme'
+        self.putmecontainer.application_category = u'bec' # doesn't matter
+        self.putmecontainer.year = 2011
+        self.putmecontainer.application_fee = 300.0
+        self.putmecontainer.title = u'This is the putme2011 container'
+        self.app['applicants']['putme2011'] = self.putmecontainer
+        delta = datetime.timedelta(days=10)
+        self.putmecontainer.startdate = datetime.datetime.now(pytz.utc) - delta
+        self.putmecontainer.enddate = datetime.datetime.now(pytz.utc) + delta
 
         # Populate university
@@ -91,4 +104,14 @@
             % self.becapplication_number)
 
+        putmeapplicant = createObject(u'waeup.Applicant')
+        putmeapplicant.firstname = u'Anna'
+        putmeapplicant.lastname = u'Post'
+        self.app['applicants']['putme2011'].addApplicant(putmeapplicant)
+        self.putmeapplication_number = putmeapplicant.application_number
+        self.putmeapplicant = self.app['applicants']['putme2011'][
+            self.putmeapplication_number]
+        self.putmeapplicant_path = ('http://localhost/app/applicants/putme2011/%s'
+            % self.putmeapplication_number)
+
         self.browser = Browser()
         self.browser.handleErrors = False
@@ -110,5 +133,5 @@
         self.browser.getControl(name="form.email").value = 'xx@yy.zz'
 
-    def test_manage_and_view_applicant(self):
+    def test_manage_and_view_bec_applicant(self):
         # Managers can manage bec applicants.
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
@@ -125,2 +148,18 @@
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
         return
+
+    def test_manage_and_view_putme_applicant(self):
+        # Managers can manage bec applicants.
+        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
+        self.browser.open(self.putmeapplicant_path)
+        self.assertEqual(self.browser.headers['Status'], '200 Ok')
+        self.assertTrue("'O' Level" in self.browser.contents)
+        self.browser.open(self.putmeapplicant_path + '/manage')
+        self.assertEqual(self.browser.headers['Status'], '200 Ok')
+        self.assertTrue("'O' Level" in self.browser.contents)
+        self.browser.open(self.putmeapplicant_path + '/edit')
+        self.assertEqual(self.browser.headers['Status'], '200 Ok')
+        self.assertTrue("'O' Level" in self.browser.contents)
+        self.browser.open(self.putmeapplicant_path + '/application_slip.pdf')
+        self.assertEqual(self.browser.headers['Status'], '200 Ok')
+        return
Index: main/waeup.fceokene/trunk/src/waeup/fceokene/utils/utils.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/utils/utils.py	(revision 10569)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/utils/utils.py	(revision 10570)
@@ -29,5 +29,5 @@
 
     APP_CATS_DICT = {
-        'basic': 'PUTME, PUDE, PCE, PRENCE',
+        'basic': 'UTME, DE, PCE, PRENCE',
         'no': 'No Application',
         'sandwich': 'Sandwich',